/*
	NEXUS2tgf.h, part of
	
	treegraph
	
	Tree formatting program
	
	Generates vector graphics (SVG,EPS) from .tgf-tree description files.

	Copyright (c) 2003-06 by Joern Mueller


	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program (GPL.html); if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
	(also: http://www.gnu.org)
*/








#ifndef __NEXUS2TGF_H__
#define __NEXUS2TGF_H__

#include <vector>
#include <fstream>
#include <string>

#include "tgf-parser.h"


class NEXUS_tree_import : public parser {
public:
	NEXUS_tree_import(std::ifstream&, std::ofstream&);
	
private:
	bool intLabels;
	bool brlens;
	bool altNexus;

	std::vector<std::string> taxa;
	std::ofstream& aus;

	int translateToTGF();
	void skipcomment();
	int readTreeLine();
	void writesettings(double schrgr, const std::string& treename="");
	
	int getnexttoken(std::string& token);

	void ignoreline(const std::string& linename);
	void ignoreblock(const std::string& blockname);
	void ignoreSymbol(int sym);
};



#endif
