/*
	tgf-error.h, part of
	
	treegraph
	
	Tree formatting program
	
	Generates vector graphics (SVG,EPS) from .tgf-tree description files.

	Copyright (c) 2003-06 by Joern Mueller


	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program (GPL.html); if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
	(also: http://www.gnu.org)
*/

#ifndef __TGF_ERROR_H__
#define __TGF_ERROR_H__

#include <string>

namespace tgfError {
	inline std::string FloatToString(float a)
	{
		char tmp[12];
		std::sprintf(tmp,"%g",a);
		return std::string(tmp);
	}
	inline std::string IntegerToString(int a)
	{
		char tmp[10];
		std::sprintf(tmp,"%d",a);
		return std::string(tmp);
	}
	
	inline std::string CharToString(char a)
	{
		char ch[2];
		ch[0]=a;
		ch[1]=0;
		return std::string(ch);
	}

	class error {
	protected:
		std::string es;
	public:
		error(std::string s=""){
			es="Error: "+s+"\n";
		}
		std::string message(){
			return es;
		}

	};


	class syntax : public error {
	public:
		syntax(int a){
			es="Error in line "+ IntegerToString(a)+".\n";
		}
		syntax(std::string msg, int a= -1){
			if(a>0){
				es="Error in line "+ IntegerToString(a) +": ";
			} else {
				es="Error: ";
			}
			es+=msg+"\n";
		}

	};




}

#endif /* __TGF_ERROR_H__ */
