
#ifndef __TGF_TREEDESC_H__
#define __TGF_TREEDESC_H__

#include "tgf-utils.h"
#include <list>

struct tree_desc
{
	bool uselength;
	bool forceauto; //Trotz Laengenangaben ...
	bool variablelength; //Zweiglaenge proportional zu Baumtiefe
	bool shownumbers;
	float extrasep; //Abstand zwischen Randknoten und Randtext. Breite eines "x"
	float thickness;
	float min_treewidth;//nur Baum, durch Beschriftung/minlength vorgegeben
	float min_treeheight;//nur Baum, durch Beschriftung/minlength vorgegeben
	float treewidth;//nur Baum
	float klammerrand;//breite des klammerrands.
	float maxrund;//maximaler Rundungsradius
	float picwidth;
	float picheight;
	std::string paper;//a0,a1,...a9,letter,legal,11x17
	bool landscape;
	float scale;
	float roundness; //0 eckig, 1 maximal rund
	float bracketcolwidth; //Platz fuer Klammern am rechten Rand
	float lenscale; //lenscale*node->len ergibt zweiglaenge in pt (wenn uselength)
	std::list<namedfontstyle> style;


	std::string colsep; //Trennung zwischen Spalten ueber Ast
	std::string treename;
	std::string treetitle;
	float tgfversion;
	fRect Rand;
	fPoint rulepos;
	
	tree_desc();
	tree_desc(const tree_desc&);
	void setstyle(const std::string& ident, const fontstyle& f);
	fontstyle getstyle(const std::string& ident) const;
	bool styleexists(const std::string& ident) const;
	float getfontsize(const nfstring& s) const;
	float helv_stringwidth(const nfstring& s) const;
	float helv_stringwidth(const std::string& s, const fontstyle& f) const;
	static void shownamedstyle(std::ostream&, const namedfontstyle& f);
	void show() const;
};



#endif /* __TGF_TREEDESC_H__ */

